/**
 * Upbit Open API
 * ## REST API for Upbit Exchange - Base URL: [https://api.upbit.com] - Official Upbit API Documents: [https://docs.upbit.com] - Official Support email: [open-api@upbit.com] 
 *
 * OpenAPI spec version: 1.0.0
 * Contact: ujhin942@gmail.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

#include "SWGDepositApi.h"
#include "SWGHelpers.h"
#include "SWGModelFactory.h"
#include "SWGQObjectWrapper.h"

#include <QJsonArray>
#include <QJsonDocument>

namespace Swagger {

SWGDepositApi::SWGDepositApi() {}

SWGDepositApi::~SWGDepositApi() {}

SWGDepositApi::SWGDepositApi(QString host, QString basePath) {
    this->host = host;
    this->basePath = basePath;
}

void
SWGDepositApi::deposit_coinAddress(QString* currency) {
    QString fullPath;
    fullPath.append(this->host).append(this->basePath).append("/deposits/coin_address");


    if (fullPath.indexOf("?") > 0)
      fullPath.append("&");
    else
      fullPath.append("?");
    fullPath.append(QUrl::toPercentEncoding("currency"))
        .append("=")
        .append(QUrl::toPercentEncoding(stringValue(currency)));


    SWGHttpRequestWorker *worker = new SWGHttpRequestWorker();
    SWGHttpRequestInput input(fullPath, "GET");





    foreach(QString key, this->defaultHeaders.keys()) {
        input.headers.insert(key, this->defaultHeaders.value(key));
    }

    connect(worker,
            &SWGHttpRequestWorker::on_execution_finished,
            this,
            &SWGDepositApi::deposit_coinAddressCallback);

    worker->execute(&input);
}

void
SWGDepositApi::deposit_coinAddressCallback(SWGHttpRequestWorker * worker) {
    QString msg;
    QString error_str = worker->error_str;
    QNetworkReply::NetworkError error_type = worker->error_type;

    if (worker->error_type == QNetworkReply::NoError) {
        msg = QString("Success! %1 bytes").arg(worker->response.length());
    }
    else {
        msg = "Error: " + worker->error_str;
    }

    QString json(worker->response);
    SWGDepositCompleteResponse* output = static_cast<SWGDepositCompleteResponse*>(create(json, QString("SWGDepositCompleteResponse")));
    auto wrapper = new SWGQObjectWrapper<SWGDepositCompleteResponse*> (output);
    wrapper->deleteLater();
    worker->deleteLater();

    if (worker->error_type == QNetworkReply::NoError) {
        emit deposit_coinAddressSignal(output);
    } else {
        emit deposit_coinAddressSignalE(output, error_type, error_str);
        emit deposit_coinAddressSignalEFull(worker, error_type, error_str);
    }
}

void
SWGDepositApi::deposit_coinAddresses() {
    QString fullPath;
    fullPath.append(this->host).append(this->basePath).append("/deposits/coin_addresses");



    SWGHttpRequestWorker *worker = new SWGHttpRequestWorker();
    SWGHttpRequestInput input(fullPath, "GET");





    foreach(QString key, this->defaultHeaders.keys()) {
        input.headers.insert(key, this->defaultHeaders.value(key));
    }

    connect(worker,
            &SWGHttpRequestWorker::on_execution_finished,
            this,
            &SWGDepositApi::deposit_coinAddressesCallback);

    worker->execute(&input);
}

void
SWGDepositApi::deposit_coinAddressesCallback(SWGHttpRequestWorker * worker) {
    QString msg;
    QString error_str = worker->error_str;
    QNetworkReply::NetworkError error_type = worker->error_type;

    if (worker->error_type == QNetworkReply::NoError) {
        msg = QString("Success! %1 bytes").arg(worker->response.length());
    }
    else {
        msg = "Error: " + worker->error_str;
    }

    QString json(worker->response);
    SWGObject* output = static_cast<SWGObject*>(create(json, QString("SWGObject")));
    auto wrapper = new SWGQObjectWrapper<SWGObject*> (output);
    wrapper->deleteLater();
    worker->deleteLater();

    if (worker->error_type == QNetworkReply::NoError) {
        emit deposit_coinAddressesSignal(output);
    } else {
        emit deposit_coinAddressesSignalE(output, error_type, error_str);
        emit deposit_coinAddressesSignalEFull(worker, error_type, error_str);
    }
}

void
SWGDepositApi::deposit_generateCoinAddress(QString* currency) {
    QString fullPath;
    fullPath.append(this->host).append(this->basePath).append("/deposits/generate_coin_address");



    SWGHttpRequestWorker *worker = new SWGHttpRequestWorker();
    SWGHttpRequestInput input(fullPath, "POST");

    if (currency != nullptr) {
        input.add_var("currency", *currency);
    }




    foreach(QString key, this->defaultHeaders.keys()) {
        input.headers.insert(key, this->defaultHeaders.value(key));
    }

    connect(worker,
            &SWGHttpRequestWorker::on_execution_finished,
            this,
            &SWGDepositApi::deposit_generateCoinAddressCallback);

    worker->execute(&input);
}

void
SWGDepositApi::deposit_generateCoinAddressCallback(SWGHttpRequestWorker * worker) {
    QString msg;
    QString error_str = worker->error_str;
    QNetworkReply::NetworkError error_type = worker->error_type;

    if (worker->error_type == QNetworkReply::NoError) {
        msg = QString("Success! %1 bytes").arg(worker->response.length());
    }
    else {
        msg = "Error: " + worker->error_str;
    }

    QString json(worker->response);
    SWGDepositCompleteResponse* output = static_cast<SWGDepositCompleteResponse*>(create(json, QString("SWGDepositCompleteResponse")));
    auto wrapper = new SWGQObjectWrapper<SWGDepositCompleteResponse*> (output);
    wrapper->deleteLater();
    worker->deleteLater();

    if (worker->error_type == QNetworkReply::NoError) {
        emit deposit_generateCoinAddressSignal(output);
    } else {
        emit deposit_generateCoinAddressSignalE(output, error_type, error_str);
        emit deposit_generateCoinAddressSignalEFull(worker, error_type, error_str);
    }
}

void
SWGDepositApi::deposit_info(QString* uuid, QString* txid, QString* currency) {
    QString fullPath;
    fullPath.append(this->host).append(this->basePath).append("/deposit");


    if (fullPath.indexOf("?") > 0)
      fullPath.append("&");
    else
      fullPath.append("?");
    fullPath.append(QUrl::toPercentEncoding("uuid"))
        .append("=")
        .append(QUrl::toPercentEncoding(stringValue(uuid)));

    if (fullPath.indexOf("?") > 0)
      fullPath.append("&");
    else
      fullPath.append("?");
    fullPath.append(QUrl::toPercentEncoding("txid"))
        .append("=")
        .append(QUrl::toPercentEncoding(stringValue(txid)));

    if (fullPath.indexOf("?") > 0)
      fullPath.append("&");
    else
      fullPath.append("?");
    fullPath.append(QUrl::toPercentEncoding("currency"))
        .append("=")
        .append(QUrl::toPercentEncoding(stringValue(currency)));


    SWGHttpRequestWorker *worker = new SWGHttpRequestWorker();
    SWGHttpRequestInput input(fullPath, "GET");





    foreach(QString key, this->defaultHeaders.keys()) {
        input.headers.insert(key, this->defaultHeaders.value(key));
    }

    connect(worker,
            &SWGHttpRequestWorker::on_execution_finished,
            this,
            &SWGDepositApi::deposit_infoCallback);

    worker->execute(&input);
}

void
SWGDepositApi::deposit_infoCallback(SWGHttpRequestWorker * worker) {
    QString msg;
    QString error_str = worker->error_str;
    QNetworkReply::NetworkError error_type = worker->error_type;

    if (worker->error_type == QNetworkReply::NoError) {
        msg = QString("Success! %1 bytes").arg(worker->response.length());
    }
    else {
        msg = "Error: " + worker->error_str;
    }

    QString json(worker->response);
    SWGDeposit* output = static_cast<SWGDeposit*>(create(json, QString("SWGDeposit")));
    auto wrapper = new SWGQObjectWrapper<SWGDeposit*> (output);
    wrapper->deleteLater();
    worker->deleteLater();

    if (worker->error_type == QNetworkReply::NoError) {
        emit deposit_infoSignal(output);
    } else {
        emit deposit_infoSignalE(output, error_type, error_str);
        emit deposit_infoSignalEFull(worker, error_type, error_str);
    }
}

void
SWGDepositApi::deposit_infoAll(QString* currency, QString* state, QList<QString*>* uuids, QList<QString*>* txids, SWGNumber* limit, SWGNumber* page, QString* order_by) {
    QString fullPath;
    fullPath.append(this->host).append(this->basePath).append("/deposits");


    if (fullPath.indexOf("?") > 0)
      fullPath.append("&");
    else
      fullPath.append("?");
    fullPath.append(QUrl::toPercentEncoding("currency"))
        .append("=")
        .append(QUrl::toPercentEncoding(stringValue(currency)));

    if (fullPath.indexOf("?") > 0)
      fullPath.append("&");
    else
      fullPath.append("?");
    fullPath.append(QUrl::toPercentEncoding("state"))
        .append("=")
        .append(QUrl::toPercentEncoding(stringValue(state)));



    if (uuids->size() > 0) {
      if (QString("multi").indexOf("multi") == 0) {
        foreach(QString* t, *uuids) {
          if (fullPath.indexOf("?") > 0)
            fullPath.append("&");
          else
            fullPath.append("?");
          fullPath.append("uuids=").append(stringValue(t));
        }
      }
      else if (QString("multi").indexOf("ssv") == 0) {
        if (fullPath.indexOf("?") > 0)
          fullPath.append("&");
        else
          fullPath.append("?");
        fullPath.append("uuids=");
        qint32 count = 0;
        foreach(QString* t, *uuids) {
          if (count > 0) {
            fullPath.append(" ");
          }
          fullPath.append(stringValue(t));
        }
      }
      else if (QString("multi").indexOf("tsv") == 0) {
        if (fullPath.indexOf("?") > 0)
          fullPath.append("&");
        else
          fullPath.append("?");
        fullPath.append("uuids=");
        qint32 count = 0;
        foreach(QString* t, *uuids) {
          if (count > 0) {
            fullPath.append("\t");
          }
          fullPath.append(stringValue(t));
        }
      }
    }



    if (txids->size() > 0) {
      if (QString("multi").indexOf("multi") == 0) {
        foreach(QString* t, *txids) {
          if (fullPath.indexOf("?") > 0)
            fullPath.append("&");
          else
            fullPath.append("?");
          fullPath.append("txids=").append(stringValue(t));
        }
      }
      else if (QString("multi").indexOf("ssv") == 0) {
        if (fullPath.indexOf("?") > 0)
          fullPath.append("&");
        else
          fullPath.append("?");
        fullPath.append("txids=");
        qint32 count = 0;
        foreach(QString* t, *txids) {
          if (count > 0) {
            fullPath.append(" ");
          }
          fullPath.append(stringValue(t));
        }
      }
      else if (QString("multi").indexOf("tsv") == 0) {
        if (fullPath.indexOf("?") > 0)
          fullPath.append("&");
        else
          fullPath.append("?");
        fullPath.append("txids=");
        qint32 count = 0;
        foreach(QString* t, *txids) {
          if (count > 0) {
            fullPath.append("\t");
          }
          fullPath.append(stringValue(t));
        }
      }
    }

    if (fullPath.indexOf("?") > 0)
      fullPath.append("&");
    else
      fullPath.append("?");
    fullPath.append(QUrl::toPercentEncoding("limit"))
        .append("=")
        .append(QUrl::toPercentEncoding(stringValue(limit)));

    if (fullPath.indexOf("?") > 0)
      fullPath.append("&");
    else
      fullPath.append("?");
    fullPath.append(QUrl::toPercentEncoding("page"))
        .append("=")
        .append(QUrl::toPercentEncoding(stringValue(page)));

    if (fullPath.indexOf("?") > 0)
      fullPath.append("&");
    else
      fullPath.append("?");
    fullPath.append(QUrl::toPercentEncoding("order_by"))
        .append("=")
        .append(QUrl::toPercentEncoding(stringValue(order_by)));


    SWGHttpRequestWorker *worker = new SWGHttpRequestWorker();
    SWGHttpRequestInput input(fullPath, "GET");





    foreach(QString key, this->defaultHeaders.keys()) {
        input.headers.insert(key, this->defaultHeaders.value(key));
    }

    connect(worker,
            &SWGHttpRequestWorker::on_execution_finished,
            this,
            &SWGDepositApi::deposit_infoAllCallback);

    worker->execute(&input);
}

void
SWGDepositApi::deposit_infoAllCallback(SWGHttpRequestWorker * worker) {
    QString msg;
    QString error_str = worker->error_str;
    QNetworkReply::NetworkError error_type = worker->error_type;

    if (worker->error_type == QNetworkReply::NoError) {
        msg = QString("Success! %1 bytes").arg(worker->response.length());
    }
    else {
        msg = "Error: " + worker->error_str;
    }

    QList<SWGDeposit*>* output = new QList<SWGDeposit*>();
    QString json(worker->response);
    QByteArray array (json.toStdString().c_str());
    QJsonDocument doc = QJsonDocument::fromJson(array);
    QJsonArray jsonArray = doc.array();
    auto wrapper = new SWGQObjectWrapper<QList<SWGDeposit*>*> (output);
    wrapper->deleteLater();
    foreach(QJsonValue obj, jsonArray) {
        SWGDeposit* o = new SWGDeposit();
        QJsonObject jv = obj.toObject();
        QJsonObject * ptr = (QJsonObject*)&jv;
        o->fromJsonObject(*ptr);
        auto objwrapper = new SWGQObjectWrapper<SWGDeposit*> (o);
        objwrapper->deleteLater();
        output->append(o);
    }
    worker->deleteLater();

    if (worker->error_type == QNetworkReply::NoError) {
        emit deposit_infoAllSignal(output);
    } else {
        emit deposit_infoAllSignalE(output, error_type, error_str);
        emit deposit_infoAllSignalEFull(worker, error_type, error_str);
    }
}


}
