/*
 * Upbit Open API
 * ## REST API for Upbit Exchange - Base URL: [https://api.upbit.com] - Official Upbit API Documents: [https://docs.upbit.com] - Official Support email: [open-api@upbit.com] 
 *
 * OpenAPI spec version: 1.0.0
 * Contact: ujhin942@gmail.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package io.swagger.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import io.swagger.client.model.OrderbookUnit;
import java.io.IOException;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;

/**
 * Orderbook
 */
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2021-02-05T03:34:59.277Z")
public class Orderbook {
  @SerializedName("market")
  private String market = null;

  @SerializedName("timestamp")
  private BigDecimal timestamp = null;

  @SerializedName("total_ask_size")
  private Double totalAskSize = null;

  @SerializedName("total_bid_size")
  private Double totalBidSize = null;

  @SerializedName("orderbook_units")
  private List<OrderbookUnit> orderbookUnits = null;

  public Orderbook market(String market) {
    this.market = market;
    return this;
  }

   /**
   * 마켓 코드
   * @return market
  **/
  @ApiModelProperty(example = "KRW-BTC", value = "마켓 코드")
  public String getMarket() {
    return market;
  }

  public void setMarket(String market) {
    this.market = market;
  }

  public Orderbook timestamp(BigDecimal timestamp) {
    this.timestamp = timestamp;
    return this;
  }

   /**
   * 호가 생성 시각
   * @return timestamp
  **/
  @ApiModelProperty(example = "1.529910247984E12", value = "호가 생성 시각")
  public BigDecimal getTimestamp() {
    return timestamp;
  }

  public void setTimestamp(BigDecimal timestamp) {
    this.timestamp = timestamp;
  }

  public Orderbook totalAskSize(Double totalAskSize) {
    this.totalAskSize = totalAskSize;
    return this;
  }

   /**
   * 호가 매도 총 잔량
   * @return totalAskSize
  **/
  @ApiModelProperty(example = "8.83621228", value = "호가 매도 총 잔량")
  public Double getTotalAskSize() {
    return totalAskSize;
  }

  public void setTotalAskSize(Double totalAskSize) {
    this.totalAskSize = totalAskSize;
  }

  public Orderbook totalBidSize(Double totalBidSize) {
    this.totalBidSize = totalBidSize;
    return this;
  }

   /**
   * 호가 매수 총량
   * @return totalBidSize
  **/
  @ApiModelProperty(example = "2.43976741", value = "호가 매수 총량")
  public Double getTotalBidSize() {
    return totalBidSize;
  }

  public void setTotalBidSize(Double totalBidSize) {
    this.totalBidSize = totalBidSize;
  }

  public Orderbook orderbookUnits(List<OrderbookUnit> orderbookUnits) {
    this.orderbookUnits = orderbookUnits;
    return this;
  }

  public Orderbook addOrderbookUnitsItem(OrderbookUnit orderbookUnitsItem) {
    if (this.orderbookUnits == null) {
      this.orderbookUnits = new ArrayList<OrderbookUnit>();
    }
    this.orderbookUnits.add(orderbookUnitsItem);
    return this;
  }

   /**
   * 호가
   * @return orderbookUnits
  **/
  @ApiModelProperty(value = "호가")
  public List<OrderbookUnit> getOrderbookUnits() {
    return orderbookUnits;
  }

  public void setOrderbookUnits(List<OrderbookUnit> orderbookUnits) {
    this.orderbookUnits = orderbookUnits;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    Orderbook orderbook = (Orderbook) o;
    return Objects.equals(this.market, orderbook.market) &&
        Objects.equals(this.timestamp, orderbook.timestamp) &&
        Objects.equals(this.totalAskSize, orderbook.totalAskSize) &&
        Objects.equals(this.totalBidSize, orderbook.totalBidSize) &&
        Objects.equals(this.orderbookUnits, orderbook.orderbookUnits);
  }

  @Override
  public int hashCode() {
    return Objects.hash(market, timestamp, totalAskSize, totalBidSize, orderbookUnits);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class Orderbook {\n");
    
    sb.append("    market: ").append(toIndentedString(market)).append("\n");
    sb.append("    timestamp: ").append(toIndentedString(timestamp)).append("\n");
    sb.append("    totalAskSize: ").append(toIndentedString(totalAskSize)).append("\n");
    sb.append("    totalBidSize: ").append(toIndentedString(totalBidSize)).append("\n");
    sb.append("    orderbookUnits: ").append(toIndentedString(orderbookUnits)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

