/*
 * Upbit Open API
 * ## REST API for Upbit Exchange - Base URL: [https://api.upbit.com] - Official Upbit API Documents: [https://docs.upbit.com] - Official Support email: [open-api@upbit.com] 
 *
 * OpenAPI spec version: 1.0.0
 * Contact: ujhin942@gmail.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.18
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/Ask', 'model/Bid'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./Ask'), require('./Bid'));
  } else {
    // Browser globals (root is window)
    if (!root.UpbitOpenApi) {
      root.UpbitOpenApi = {};
    }
    root.UpbitOpenApi.Market = factory(root.UpbitOpenApi.ApiClient, root.UpbitOpenApi.Ask, root.UpbitOpenApi.Bid);
  }
}(this, function(ApiClient, Ask, Bid) {
  'use strict';

  /**
   * The Market model module.
   * @module model/Market
   * @version 1.0.0
   */

  /**
   * Constructs a new <code>Market</code>.
   * 마켓에 대한 정보
   * @alias module:model/Market
   * @class
   */
  var exports = function() {
  };

  /**
   * Constructs a <code>Market</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/Market} obj Optional instance to populate.
   * @return {module:model/Market} The populated <code>Market</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();
      if (data.hasOwnProperty('id'))
        obj.id = ApiClient.convertToType(data['id'], 'String');
      if (data.hasOwnProperty('name'))
        obj.name = ApiClient.convertToType(data['name'], 'String');
      if (data.hasOwnProperty('order_types'))
        obj.orderTypes = ApiClient.convertToType(data['order_types'], ['String']);
      if (data.hasOwnProperty('order_sides'))
        obj.orderSides = ApiClient.convertToType(data['order_sides'], ['String']);
      if (data.hasOwnProperty('bid'))
        obj.bid = Bid.constructFromObject(data['bid']);
      if (data.hasOwnProperty('ask'))
        obj.ask = Ask.constructFromObject(data['ask']);
      if (data.hasOwnProperty('max_total'))
        obj.maxTotal = ApiClient.convertToType(data['max_total'], 'String');
      if (data.hasOwnProperty('state'))
        obj.state = ApiClient.convertToType(data['state'], 'String');
    }
    return obj;
  }

  /**
   * 마켓 ID
   * @member {String} id
   */
  exports.prototype.id = undefined;

  /**
   * 마켓 이름
   * @member {String} name
   */
  exports.prototype.name = undefined;

  /**
   * 지원 주문 방식
   * @member {Array.<String>} orderTypes
   */
  exports.prototype.orderTypes = undefined;

  /**
   * 지원 주문 종류
   * @member {Array.<String>} orderSides
   */
  exports.prototype.orderSides = undefined;

  /**
   * @member {module:model/Bid} bid
   */
  exports.prototype.bid = undefined;

  /**
   * @member {module:model/Ask} ask
   */
  exports.prototype.ask = undefined;

  /**
   * 최대 매도/매수 금액
   * @member {String} maxTotal
   */
  exports.prototype.maxTotal = undefined;

  /**
   * 마켓 운영 상태
   * @member {String} state
   */
  exports.prototype.state = undefined;


  return exports;

}));
