# Upbit Open API
#
# ## REST API for Upbit Exchange - Base URL: [https://api.upbit.com] - Official Upbit API Documents: [https://docs.upbit.com] - Official Support email: [open-api@upbit.com] 
#
# OpenAPI spec version: 1.0.0
# Contact: ujhin942@gmail.com
# Generated by: https://github.com/swagger-api/swagger-codegen.git


#' CandleDate Class
#'
#' @field market 
#' @field candle_date_time_utc 
#' @field candle_date_time_kst 
#' @field opening_price 
#' @field high_price 
#' @field low_price 
#' @field trade_price 
#' @field timestamp 
#' @field candle_acc_trade_price 
#' @field candle_acc_trade_volume 
#' @field first_day_of_period 
#'
#' @importFrom R6 R6Class
#' @importFrom jsonlite fromJSON toJSON
#' @export
CandleDate <- R6::R6Class(
  'CandleDate',
  public = list(
    `market` = NULL,
    `candle_date_time_utc` = NULL,
    `candle_date_time_kst` = NULL,
    `opening_price` = NULL,
    `high_price` = NULL,
    `low_price` = NULL,
    `trade_price` = NULL,
    `timestamp` = NULL,
    `candle_acc_trade_price` = NULL,
    `candle_acc_trade_volume` = NULL,
    `first_day_of_period` = NULL,
    initialize = function(`market`, `candle_date_time_utc`, `candle_date_time_kst`, `opening_price`, `high_price`, `low_price`, `trade_price`, `timestamp`, `candle_acc_trade_price`, `candle_acc_trade_volume`, `first_day_of_period`){
      if (!missing(`market`)) {
        stopifnot(is.character(`market`), length(`market`) == 1)
        self$`market` <- `market`
      }
      if (!missing(`candle_date_time_utc`)) {
        stopifnot(is.character(`candle_date_time_utc`), length(`candle_date_time_utc`) == 1)
        self$`candle_date_time_utc` <- `candle_date_time_utc`
      }
      if (!missing(`candle_date_time_kst`)) {
        stopifnot(is.character(`candle_date_time_kst`), length(`candle_date_time_kst`) == 1)
        self$`candle_date_time_kst` <- `candle_date_time_kst`
      }
      if (!missing(`opening_price`)) {
        stopifnot(is.numeric(`opening_price`), length(`opening_price`) == 1)
        self$`opening_price` <- `opening_price`
      }
      if (!missing(`high_price`)) {
        stopifnot(is.numeric(`high_price`), length(`high_price`) == 1)
        self$`high_price` <- `high_price`
      }
      if (!missing(`low_price`)) {
        stopifnot(is.numeric(`low_price`), length(`low_price`) == 1)
        self$`low_price` <- `low_price`
      }
      if (!missing(`trade_price`)) {
        stopifnot(is.numeric(`trade_price`), length(`trade_price`) == 1)
        self$`trade_price` <- `trade_price`
      }
      if (!missing(`timestamp`)) {
        self$`timestamp` <- `timestamp`
      }
      if (!missing(`candle_acc_trade_price`)) {
        stopifnot(is.numeric(`candle_acc_trade_price`), length(`candle_acc_trade_price`) == 1)
        self$`candle_acc_trade_price` <- `candle_acc_trade_price`
      }
      if (!missing(`candle_acc_trade_volume`)) {
        stopifnot(is.numeric(`candle_acc_trade_volume`), length(`candle_acc_trade_volume`) == 1)
        self$`candle_acc_trade_volume` <- `candle_acc_trade_volume`
      }
      if (!missing(`first_day_of_period`)) {
        stopifnot(is.character(`first_day_of_period`), length(`first_day_of_period`) == 1)
        self$`first_day_of_period` <- `first_day_of_period`
      }
    },
    toJSON = function() {
      CandleDateObject <- list()
      if (!is.null(self$`market`)) {
        CandleDateObject[['market']] <- self$`market`
      }
      if (!is.null(self$`candle_date_time_utc`)) {
        CandleDateObject[['candle_date_time_utc']] <- self$`candle_date_time_utc`
      }
      if (!is.null(self$`candle_date_time_kst`)) {
        CandleDateObject[['candle_date_time_kst']] <- self$`candle_date_time_kst`
      }
      if (!is.null(self$`opening_price`)) {
        CandleDateObject[['opening_price']] <- self$`opening_price`
      }
      if (!is.null(self$`high_price`)) {
        CandleDateObject[['high_price']] <- self$`high_price`
      }
      if (!is.null(self$`low_price`)) {
        CandleDateObject[['low_price']] <- self$`low_price`
      }
      if (!is.null(self$`trade_price`)) {
        CandleDateObject[['trade_price']] <- self$`trade_price`
      }
      if (!is.null(self$`timestamp`)) {
        CandleDateObject[['timestamp']] <- self$`timestamp`
      }
      if (!is.null(self$`candle_acc_trade_price`)) {
        CandleDateObject[['candle_acc_trade_price']] <- self$`candle_acc_trade_price`
      }
      if (!is.null(self$`candle_acc_trade_volume`)) {
        CandleDateObject[['candle_acc_trade_volume']] <- self$`candle_acc_trade_volume`
      }
      if (!is.null(self$`first_day_of_period`)) {
        CandleDateObject[['first_day_of_period']] <- self$`first_day_of_period`
      }

      CandleDateObject
    },
    fromJSON = function(CandleDateJson) {
      CandleDateObject <- jsonlite::fromJSON(CandleDateJson)
      if (!is.null(CandleDateObject$`market`)) {
        self$`market` <- CandleDateObject$`market`
      }
      if (!is.null(CandleDateObject$`candle_date_time_utc`)) {
        self$`candle_date_time_utc` <- CandleDateObject$`candle_date_time_utc`
      }
      if (!is.null(CandleDateObject$`candle_date_time_kst`)) {
        self$`candle_date_time_kst` <- CandleDateObject$`candle_date_time_kst`
      }
      if (!is.null(CandleDateObject$`opening_price`)) {
        self$`opening_price` <- CandleDateObject$`opening_price`
      }
      if (!is.null(CandleDateObject$`high_price`)) {
        self$`high_price` <- CandleDateObject$`high_price`
      }
      if (!is.null(CandleDateObject$`low_price`)) {
        self$`low_price` <- CandleDateObject$`low_price`
      }
      if (!is.null(CandleDateObject$`trade_price`)) {
        self$`trade_price` <- CandleDateObject$`trade_price`
      }
      if (!is.null(CandleDateObject$`timestamp`)) {
        self$`timestamp` <- CandleDateObject$`timestamp`
      }
      if (!is.null(CandleDateObject$`candle_acc_trade_price`)) {
        self$`candle_acc_trade_price` <- CandleDateObject$`candle_acc_trade_price`
      }
      if (!is.null(CandleDateObject$`candle_acc_trade_volume`)) {
        self$`candle_acc_trade_volume` <- CandleDateObject$`candle_acc_trade_volume`
      }
      if (!is.null(CandleDateObject$`first_day_of_period`)) {
        self$`first_day_of_period` <- CandleDateObject$`first_day_of_period`
      }
    },
    toJSONString = function() {
       sprintf(
        '{
           "market": %s,
           "candle_date_time_utc": %s,
           "candle_date_time_kst": %s,
           "opening_price": %d,
           "high_price": %d,
           "low_price": %d,
           "trade_price": %d,
           "timestamp": %s,
           "candle_acc_trade_price": %d,
           "candle_acc_trade_volume": %d,
           "first_day_of_period": %s
        }',
        self$`market`,
        self$`candle_date_time_utc`,
        self$`candle_date_time_kst`,
        self$`opening_price`,
        self$`high_price`,
        self$`low_price`,
        self$`trade_price`,
        self$`timestamp`,
        self$`candle_acc_trade_price`,
        self$`candle_acc_trade_volume`,
        self$`first_day_of_period`
      )
    },
    fromJSONString = function(CandleDateJson) {
      CandleDateObject <- jsonlite::fromJSON(CandleDateJson)
      self$`market` <- CandleDateObject$`market`
      self$`candle_date_time_utc` <- CandleDateObject$`candle_date_time_utc`
      self$`candle_date_time_kst` <- CandleDateObject$`candle_date_time_kst`
      self$`opening_price` <- CandleDateObject$`opening_price`
      self$`high_price` <- CandleDateObject$`high_price`
      self$`low_price` <- CandleDateObject$`low_price`
      self$`trade_price` <- CandleDateObject$`trade_price`
      self$`timestamp` <- CandleDateObject$`timestamp`
      self$`candle_acc_trade_price` <- CandleDateObject$`candle_acc_trade_price`
      self$`candle_acc_trade_volume` <- CandleDateObject$`candle_acc_trade_volume`
      self$`first_day_of_period` <- CandleDateObject$`first_day_of_period`
    }
  )
)
